/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/

package client.logger;

import java.io.Serializable;
import java.util.HashMap;
import java.util.LinkedHashMap;

import server.ABServer;

public class Configuration implements Serializable {
/**
	 * 
	 */
private static final long serialVersionUID = -1106687524458529457L;
private int player_id;
private int current_level;

private LinkedHashMap<Integer,Integer> gScore;
private int totalScore = 0;

public int getTotalScore() 
{
	return totalScore;
}
public void setTotalScore(int totalscore)
{
	this.totalScore = totalscore;
}
public int getPlayer_id() {
	return player_id;
}


public Configuration(int player_id, int current_level, 
		LinkedHashMap<Integer, Integer> score) {
	super();
	this.player_id = player_id;
	this.current_level = current_level;

	if(!score.isEmpty())
		this.gScore = score;
	else {
		this.gScore = new LinkedHashMap<Integer, Integer>();
		for (int i = 1; i <= ABServer.level; i ++)
		{
			this.gScore.put(i, 0);
		}
	}
}
public int getCurrent_level() {
	return current_level;
}
public void setCurrent_level(int current_level) {
	this.current_level = current_level;
}
public HashMap<Integer, Integer> getScore() {
	return gScore;
}
public void setLevel_grades(LinkedHashMap<Integer, Integer> level_grades) {
	this.gScore = level_grades;
}

public void updateScore(int score)
{
    if(!gScore.containsKey(current_level))
    {
    	gScore.put(current_level, score);
    	totalScore += score;
    }
    else
    {
    	int prev_score = gScore.get(current_level);
        if(prev_score < score)
        {
        	gScore.put(current_level, score);
        	totalScore += score - prev_score;
        }
    }   
    
    for (Integer level: gScore.keySet())
    {
    	if(gScore.get(level) == 0)
    	{
    		//solvedAllFlag = -1;//For benchmark only
    		break;
    	}
    } 
   /* if(solvedAllFlag == 1) //For benchmark only
    {
    	this.solvedAll = System.currentTimeMillis();
    	solvedAllFlag = 3;
    } 
    else
    	 if(solvedAllFlag != 3)
    		solvedAllFlag = 1 ;*/
}
@Override
public String toString()
{
	StringBuilder result = new StringBuilder();
	result.append("\n------------- Configuration: --------------\n");
	result.append(" Client ID: " + player_id + "\n last Level: " + current_level 
			+"\n total score: " + totalScore) ;

		
	for (Integer key: gScore.keySet())
	{
		result.append("\n Level: " + key + " Score: " + gScore.get(key)); 
	}
	/*if(this.solvedAll != 0)
	{
		result.append("\n Solve all the levels in : " + (this.solvedAll - ABServerManager.current_time)/1000 + " secs");
	}*/
    return result.toString();
}

}
