/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/

package display;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Observable;
import java.util.Observer;

import server.util.Log;
import client.logger.AgentLogger;



public class DisplayForwardingAgent implements Runnable,Observer {
	private ServerSocket displaySocket;
	private Socket deviceSocket = null;
	private ObjectOutputStream out;
	//private OutputStream out;
	private InputStream in;
	public DisplayForwardingAgent() throws IOException {
		this.displaySocket = new ServerSocket(2005, 1);
	}
	@Override
	public void run() 
	{
		while(true)
		{
			System.out.println(" waiting for display device ");
			try 
			{
					deviceSocket = displaySocket.accept();
					out = new ObjectOutputStream(deviceSocket.getOutputStream());
					//out = deviceSocket.getOutputStream();
					in = deviceSocket.getInputStream();
					System.out.println(" Display Device Connected ");
			} 
			catch (IOException e) {
				
					e.printStackTrace();
			}
        }
	}
	@Override
	public synchronized void update(Observable o, Object arg) {
		//If a level has been solved, send the shots, the team_id, and scores. 
		if(o instanceof AgentLogger && deviceSocket != null)
		{
			
			byte[] messages = (byte[]) arg;
			AgentLogger logger = (AgentLogger)o;
			if(!logger.getScreenshots().isEmpty())
			try {
				Log.echo(" screenshots send off ");
				//out.reset();
				out.write(messages);
				out.flush();
				String screenshots;
				screenshots = logger.getScreenshots();
			
				out.writeUTF(screenshots);
				out.flush();
			
				in.read();
				//System.out.println("read confirmation");
			} catch (IOException e) {
				
				e.printStackTrace();
			}
		}
		
	}
	

}
