/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/

package io;

import java.awt.Point;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class LevelVerificationFileIO {
	public static void generateLevelVerificationFile(int round)
	{
		File file = new File("levelVerification_" + round + ".txt");
		if (file.exists())
			file.delete();
		try {
			file.createNewFile();
			
		}
		catch (IOException e) 
		{
			e.printStackTrace();
		}
	}
	public static List<Point> readLevelVerificationFile(int round)
	{
		File file = new File("levelVerificationR_" + round +".txt");
		List<Point> levelVerification = new ArrayList<Point>();
		try {
			BufferedReader fr = new BufferedReader(new FileReader(file));
			try {
				while(fr.ready())
				{
					String line = fr.readLine();
					//String level_str = line.substring(0, line.indexOf(","));
					//int level = Integer.parseInt(level_str);
					line = line.substring(line.indexOf(",") + 1);
					String x_str = line.substring(0, line.indexOf(","));
					int x = Integer.parseInt(x_str);
					line = line.substring(line.indexOf(",") + 1);
					int y = Integer.parseInt(line);
					levelVerification.add(new Point(x, y));
				}
				fr.close();

			} catch (NumberFormatException | IOException e) {
				System.out.println("Do not use the level selection");
			}
			
			
		} catch (FileNotFoundException e) {
		
			System.out.println("Do not use the level selection");
		} 
		return levelVerification;
	}
}
