/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/

package proxy;

import java.util.concurrent.SynchronousQueue;

import org.java_websocket.WebSocket;

public class AgentRequestHandler {
	protected WebSocket chrome_window;
	protected SynchronousQueue<Object> result;
	protected ProxyMessage<?> message; 
	protected boolean waiting = false;
	public AgentRequestHandler(WebSocket chrome_window) {
		super();
		this.chrome_window = chrome_window;
		result = new SynchronousQueue<Object>();
	}

	public WebSocket getChrome_window() {
		return chrome_window;
	}

	public void setMessage(ProxyMessage<?> message) {
		this.message = message;
	}

	public ProxyMessage<?> getMessage() {
		return message;
	}
	@SuppressWarnings("unchecked")
	public <T> T send(ProxyMessage<?> message)
	{
		this.message = message;
		waiting = true;
		try {
			return (T)result.take();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	}
