/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/

package server.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class CheckUsedLevels {
	
private BufferedReader br;
private String iniKeys[];
private String dir;
private String targetFileDir;

public CheckUsedLevels(String targetFileDir, String dir) {
	super();
	this.targetFileDir = targetFileDir;
	this.dir = dir;
}
private void run()
{
	//read file
	File targetDir = new File(targetFileDir);
	File[] allTargetFiles = targetDir.listFiles();
	for (File targetFile : allTargetFiles)
	{
	System.out.println("Process " + targetFile);
 	iniKeys = new String[2];
 	iniKeys = getId(targetFile);
 //	System.out.println(iniKeys[0] + " " + iniKeys[1]);
	File file = new File(dir);
	if (file.isDirectory())
	for (File lfile : file.listFiles())
	{
		if (match(lfile))
			break;
	}

	}
}
private boolean match(File file)
{
	String[] keys = getId(file);
	if (iniKeys[0].equalsIgnoreCase(keys[0]) && iniKeys[1].equalsIgnoreCase(keys[1]) )
	{
		System.out.println("Used Level Detected " + file.getName() + " iniKey 0 " + iniKeys[0] + "  iniKey 1 " + iniKeys[1]);
		return true;
	}
	return false;
		

}
private String[] getId(File file)
{
	String[] keys = new String[2];
	int count = 0;
	try {
		br = new BufferedReader(new FileReader(file));
		while(br.ready() && count < 2)
		{
			String line = br.readLine();
			if (line.contains("bottom") && count < 1)
			{
				keys[0] = line;
				count ++;
			}
			else
				if (line.contains("blocks"))
				{
					keys[1] = line;
					count ++;
				}
		}
		br.close();
		} catch (IOException e) {
	
		e.printStackTrace();
	}
	return keys;
}
public static void main(String args[])
{
	CheckUsedLevels cul = new CheckUsedLevels(args[0], args[1]);
	cul.run();
}
}
