/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/
package server.util;

import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.IOException;

import javax.imageio.ImageIO;

import server.ABServer;
import vision.Vision;
import vision.GameStateExtractor.GameState;


public class ServerMessageEncoder {

	public static final byte[] OK = { 1 };
	public static final byte[] ERR = { 0 };
    public static final byte[] TERMINATE = {-1};
	public byte[] econdeConfiguration() {
		byte[] result = { ABServer.round, ABServer.time_limit, ABServer.level };
		return result;
	}
	

	public byte[] encodeScreenShot(byte[] image)
    {
    
    	 BufferedImage bfimage = null;
    	 byte[] imageMessage = null;
         try {
             bfimage = ImageIO.read(new ByteArrayInputStream(image));
             byte[] rawbytes = Vision.decodeImage(bfimage);
             byte[] width = intToByteArray(bfimage.getWidth());
             byte[] height = intToByteArray(bfimage.getHeight());
             imageMessage = new byte[rawbytes.length + 8];
             System.arraycopy(width, 0, imageMessage, 0, 4);
             System.arraycopy(height, 0, imageMessage, 4, 4);
             System.arraycopy(rawbytes, 0, imageMessage, 8, rawbytes.length);
             
               } catch (IOException e) {
             e.printStackTrace();
         }
         //System.out.println(bytesToInt(imageMessage[0],imageMessage[1],imageMessage[2],imageMessage[3]));
    	return imageMessage;
    	
    }
	public int bytesToInt(byte... b) {
		int value = 0;
		for (int i = 0; i < 4; i++) {
			int shift = (4 - 1 - i) * 8;
			value += (b[i] & 0x000000FF) << shift;
		}
		return value;
	}
	public byte[] intToByteArray(int a) {
		byte[] ret = new byte[4];
		ret[3] = (byte) (a & 0xFF);
		ret[2] = (byte) ((a >> 8) & 0xFF);
		ret[1] = (byte) ((a >> 16) & 0xFF);
		ret[0] = (byte) ((a >> 24) & 0xFF);
		return ret;
	}
	
	public byte[] encodeState(GameState state) {
		byte ordinal = (byte) state.ordinal();
		byte[] ordinalState = { ordinal };
		return ordinalState;
	}
	

}
